﻿Lua_NewServerActivityItem = class("Lua_NewServerActivityItem", Lua_ListCell);
function Lua_NewServerActivityItem:ctor(p)
    self:superCall("ctor", p, "NewServerActivityItem_skin");
end
function Lua_NewServerActivityItem:buildShowItem()
    self:superCall("buildShowItem");
    self.rewardArr = Array()
    self.effectArr = Array()
end

function Lua_NewServerActivityItem:setData(data)
    self._data = data
    self.itemTxt.text = data.desTxt

    self:createMark(data)
    self:createReward(data)
    self:createEffect(data)
end

function Lua_NewServerActivityItem:createMark(data)
    -- 去除活动结束才显示结果
    -- if DataCenter.newServerActivityData.ActState == true then
    --     if data.greenMark == true then
    --         self.stateSp:setEnable(false)
    --         self.stateSp:setAltas("common_atlas_3", "ui_common_b_yidahceng")
    --     else
    --         self.stateSp:setEnable(false)
    --         self.stateSp:setAltas("common_atlas_3", "ui_common_b_yidahceng1")
    --     end
    -- else
        if data.greenMark == true then
            self.stateSp:setEnable(true)
            self.stateSp:setAltas("common_atlas_3", "ui_common_b_yidahceng")
        else
            self.stateSp:setEnable(data.greenMark ~= nil)
            self.stateSp:setAltas("common_atlas_3", "ui_common_b_yidahceng1")
        end
    -- end
end

function Lua_NewServerActivityItem:createReward(data)
    local len = self.rewardArr:getSize()
    for i = 1, len do
        self.rewardArr[i]:dispose()
    end
    self.rewardArr:clear()
    local rewardLen = data.voArr:getSize()
    for i = 1, rewardLen do
        local item = Lua_ToolImage.new(self.content);
        item:setDepth(5);
        item:setScale(0.88, 0.88, 0.88);
        item:setLocation(-185 +(i - 1) * 85, -15, 0)
        item.data = data.voArr[i]
        item:showNotYetImg(false)
        item:showMaskSp(false)
        self.rewardArr:add(item)
    end
end

function Lua_NewServerActivityItem:checkOutBound(showRect)
    if self._data == nil then
        self.inViewEffect = false;
        return;
    end

    local rect = Lua_Rectangle.new(self.itemX - 50, self.itemY - 30, 100,62);
    if showRect:containeRect(rect) == true then
        self.inViewEffect = true;
    else
        self.inViewEffect = false;
    end

    self:updateEffectState();
end

function Lua_NewServerActivityItem:updateEffectState()
    local len = self.effectArr:getSize();
    if self.inViewEffect == true then
        for i=1,len do
            self.effectArr[i]:setEnable(true);
        end
    else
        for i=1,len do
            self.effectArr[i]:setEnable(false);
        end
    end
end

function Lua_NewServerActivityItem:createEffect(data)
    local len = self.effectArr:getSize()
    for i = 1, len do
        self.effectArr[i]:dispose()
    end
    self.effectArr:clear()
    local rewardLen = self.rewardArr:getSize()
    local effectItemArr = data.effectArr
    local len = #effectItemArr
    for i = 1, rewardLen do
        for c = 1, len do
            if self.rewardArr[i].data.id == tonumber(tostring(effectItemArr[c])) then
                local effect = UICreate.createUIEffect(self.content, nil, nil, 0, 0);
                effect:setSacle(0.78, 0.78, 0.78);
                effect:SetRenderQueue(self.itemSp, 5, 2, false);
                if self.rewardArr[i].data.color == 3 then
                    effect:setUrl("/effects/scsEffects/gui_purple_box", "gui_purple_box");
                elseif self.rewardArr[i].data.color == 4 then
                    effect:setUrl("/effects/scsEffects/gui_orange_box", "gui_orange_box");
                elseif self.rewardArr[i].data.color == 5 then
                    effect:setUrl("/effects/scsEffects/gui_red_box", "gui_red_box");
                elseif self.rewardArr[i].data.color == 6 then
                    effect:setUrl("/effects/scsEffects/gui_pink_box", "gui_pink_box");
                end
                effect:setLocation(self.rewardArr[i].mainContent.transform.localPosition.x, self.rewardArr[i].mainContent.transform.localPosition.y, 0)
                self.effectArr:add(effect)
            end
        end
    end
end

function Lua_NewServerActivityItem:dispose()
    self:superCall("dispose");
end
