﻿-- 开服冲榜
checkRequire("Lua_NewServerActivityItem")
checkRequire("Lua_NewServerConfigItem")
Lua_NewServerActivityWindow = class("Lua_NewServerActivityWindow", Lua_Window)
function Lua_NewServerActivityWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_NewServerActivityWindow";
	self.skinName = "NewServerActivityWindow_skin";
end

function Lua_NewServerActivityWindow:buildShowItem()
	self:superCall("buildShowItem");

	if DataCenter.newServerActivityData.CurSelectedIndex ~= -1 then
		self.curSelectedIndex = DataCenter.newServerActivityData.CurSelectedIndex;
	else
		self.curSelectedIndex = 1;
	end

	self.btnList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 800, 70));
	self.btnList:setListCell(Lua_ButtonItem, 75, 150, 100);
	self.btnList:setLocation(-92, 218, 0);

	self.rewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 476, 420));
	self.rewardList:setListCell(Lua_NewServerActivityItem, 125, 485, 1);
	self.rewardList:setLocation(-15, -36, 0);

	self.configList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 240, 228));
	self.configList:setListCell(Lua_NewServerConfigItem, 105, 120, 2);
	self.configList:setLocation(354, -68, 0);

	self.help:addClickFuntion(self, self.onHelpClick);
	self.rankBtn:addClickFuntion(self, self.onLookRankClick);

	self:createAndUpdataButtonList();

	self:addLuaEvent("UPDATE_NEWSERVER_ACTDATA", self, self.createAndUpdateDragList);
	self:addLuaEvent("ON_NEWSERVER_ITEM_CLICK", self, self.onButtonListClick);
	DataCenter.OperationalActivitiesData:sGetActivitiesInfo();
end

function Lua_NewServerActivityWindow:createAndUpdataButtonList()
	self.btnNamesInfo = DataCenter.newServerActivityData.NewServerRankButton;
	self.btnNames = Array()
	for i = 1, self.btnNamesInfo:getSize() do
		self.btnNames:add({
			act_index = self.btnNamesInfo[i].act_index,
			first_type = self.btnNamesInfo[i].first_type,
			second_type = self.btnNamesInfo[i].second_type,
			name = self.btnNamesInfo[i].title,
			sub = self.btnNamesInfo[i].sub,
			value = self.btnNamesInfo[i].value
		});
	end
	self.btnList:setLuaArrayData(self.btnNames, false);

	if self.btnNames:getSize() > 0 then
		if self.btnNames:getSize() >= self.curSelectedIndex then
			self.btnList:setSelected(self.curSelectedIndex);
			self:onButtonListClick(self.curSelectedIndex);
		else
			self.btnList:setSelected(1);
			self:onButtonListClick(1);
		end
	end
end

function Lua_NewServerActivityWindow:onButtonListClick(val)
	if self.btnNames[val].value == 1 then -- 为 1 弹出多少天开启
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(122574), tostring(self.btnNames[val].sub)));
		
		-- print("select", self.preIdx, self.curSelectedIndex);
		self.btnList:setSelected(self.curSelectedIndex);
		if self.preIdx == self.curSelectedIndex then -- 相同不进行请求
			self:onButtonListClick(self.curSelectedIndex);
		end
		return;
	end
	self.preIdx = self.curSelectedIndex;
	self.curSelectedIndex = val;
	self:getActivityInfo();
end

function Lua_NewServerActivityWindow:getActivityInfo()
	DataCenter.OperationalActivitiesData:sGetOperationalActivities(self.btnNames[self.curSelectedIndex].act_index, self.btnNames[self.curSelectedIndex].first_type);
end

function Lua_NewServerActivityWindow:createAndUpdateDragList()
	self.rewardList:setLuaArrayData(DataCenter.newServerActivityData.rewardArr, false)
	self.configList:setLuaArrayData(DataCenter.newServerActivityData.configArr, false)
	if DataCenter.newServerActivityData.ActState == true then
		self:onActTimeDown()
		self:onActTimeChange()
	end
	self:configDataChange()
end

function Lua_NewServerActivityWindow:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, DataCenter.newServerActivityData.content);
end

function Lua_NewServerActivityWindow:onActTimeChange()
	Lua_CommonUtil.addTimer("onActTimeDown", 1, self, self.onActTimeDown);
end

function Lua_NewServerActivityWindow:onActTimeDown()
	local totalTime = DataCenter.newServerActivityData.stop_tick
	local leftTime = totalTime - tonumber(tostring(GlobalVar.cur_tick))
	if leftTime < 0 then
		Lua_CommonUtil.removeTimer(self, self.onActTimeDown);
		self.timeTxt.text = LanUtil.getValue(127201)
		self:getActivityInfo()
	else
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(127200), tostring(TimeTransform.getInstance():transSeconds9(leftTime)))
	end
end

function Lua_NewServerActivityWindow:configDataChange()
	self.rankTxt.text = DataCenter.newServerActivityData.rankStr
	self.lvlTxt.text = DataCenter.newServerActivityData.lvlStr
	self.todoTxt.text = DataCenter.newServerActivityData.todo_txt;
	self.tips.text = DataCenter.newServerActivityData.tips_txt;
	self.xuanchuanSp:setUrl(DataCenter.newServerActivityData.img_path)
	if DataCenter.newServerActivityData.ActState == false then
		self.timeTxt.text = LanUtil.getValue(127201)
	end
end

function Lua_NewServerActivityWindow:onLookRankClick()
	Lua_WindowUtil.openWin("Lua_NewServerRankWindow", WinParam.ACTION_OPEN);
end

function Lua_NewServerActivityWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.configList ~= nil then
		self.configList:dispose();
		self.configList = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onActTimeDown);

	self:superCall("dispose");
end







Lua_ButtonItem = class("Lua_ButtonItem", Lua_ListCell)
function Lua_ButtonItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ButtonItem:buildShowItem()
	self:superCall("buildShowItem");

	self.buttonBg = UICreate.createUIAtlasImage(self.content, "", "", 0, -1, 152, 46);
	self.buttonBg:setDepth(4);

	self.buttonTxt = UICreate.createLabel(self.content, "", 0, 0, 110, 30, 24);
	self.buttonTxt.pivot = UIWidget.Pivot.Center;
	self.buttonTxt:setDepth(5);
end

function Lua_ButtonItem:onPlayerSoundClick()
	Lua_MsgUtil.callFunc("ON_NEWSERVER_ITEM_CLICK", self.cellSeqIndex);
end

function Lua_ButtonItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.buttonTxt.text = data.name;
end

function Lua_ButtonItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	-- 策划要求未开启的点击无效
	if val and self._data.value ~= 1 then
		self.buttonBg:setAltas("common_atlas_2", "ui_common_btn_y13");
		self.buttonTxt.colorStr = Lua_ColorDefine.transColor("ffffff");
		self.buttonBg:setLocation(0, 3);
		self.buttonTxt:setLocation(0, 4);
	else
		self.buttonBg:setAltas("common_atlas_2", "ui_common_btn_y12");
		self.buttonTxt.colorStr = Lua_ColorDefine.transColor("8ABAC8");
		self.buttonBg:setLocation(0, -1);
		self.buttonTxt:setLocation(0, 0);
	end
end

function Lua_ButtonItem:dispose()
	if self.buttonBg ~= nil then
		self.buttonBg:dispose();
		self.buttonBg = nil;
	end
	if self.buttonTxt ~= nil then
		self.buttonTxt:dispose();
		self.buttonTxt = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end