checkRequire("Lua_NewServerRankItem")
Lua_NewServerRankWindow = class("Lua_NewServerRankWindow", Lua_Window)
function Lua_NewServerRankWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_NewServerRankWindow";
	self.skinName = "NewServerRankWindow_skin";
	self.isModel = true;
end

function Lua_NewServerRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	if DataCenter.newServerActivityData.second_type ~= nil then
		DataCenter.LeaderBoardData:getleaderBoard(DataCenter.newServerActivityData.second_type, 0)
	end

	self.rank_DragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 521, 385));
	self.rank_DragList:setListCell(Lua_NewServerRankItem, 90, 521, 1);
	self.rank_DragList:setLocation(0, -14, 0);

	self:addLuaEvent("LEADERBOARD_UPDATE", self, self.createAndUpdateDragList);
end

function Lua_NewServerRankWindow:createAndUpdateDragList()
	local rankDataArr = DataCenter.LeaderBoardData.rankArr;
	local count = DataCenter.newServerActivityData.rank_count;
	local arr = Array();
	for i = 1, rankDataArr:getSize() do
		if i <= count then
			arr:add(rankDataArr[i]);
		end
	end
	self.rank_DragList:setLuaArrayData(arr, false);

	self.myRank.text = DataCenter.newServerActivityData.rankStr2;
	self.lvlTxt.text = DataCenter.newServerActivityData.rank_title;
end

function Lua_NewServerRankWindow:dispose()
	if self.rank_DragList ~= nil then
		self.rank_DragList:dispose();
		self.rank_DragList = nil;
	end
	self:superCall("dispose");
end